<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Tip extends Model
{
    use HasFactory;

    protected $appends = ['amount_formatted'];

    public function getAmountFormattedAttribute()
    {
        return number_format(($this->amount)*(pow(10, -12)), 8, '.', '');
    }

    public function address()
    {
        return $this->belongsTo(Address::class);
    }

}
