@extends('layouts.app')

@section('content')

<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-12">
            <nav aria-label="breadcrumb">
                <ol class="breadcrumb bg-light">
                    <li class="breadcrumb-item"><a href="{{ route('homepage') }}">All Memes</a></li>
                    <li class="breadcrumb-item active" aria-current="page">Meme {{ $data['meme']->id }}</li>
                </ol>
            </nav>
        </div>
        <div class="col-md-6 text-center">
            <div class="card">
                <div class="card-header">
                    <h5 class="card-title">{{ $data['meme']->title }}</h5>
                    <p class="card-text">By: <a href="{{ url('/user/' . $data['meme']->user->id) }}">{{ $data['meme']->user->name }}</a></p>
                </div>
                @if ($data['meme']->image)
                    <a href="{{ url($data['meme']->image) }}">
                        <img src="{{ url($data['meme']->image) }}" class="card-img-top" alt="{{ $data['meme']->title }} Meme">
                    </a>
                @else
                    <img src="https://picsum.photos/800" class="card-img-top" alt="{{ $data['meme']->title }} Meme">
                @endif
                <div class="card-body p-0 pt-3">
                    {!!html_entity_decode($data['share'])!!}
                </div>
                <div class="card-footer">
                    <h5 class="card-title">{{ $data['meme']->meme_tips_total }} XMR Recieved</h5>
                    <p class="card-text">Published {{ $data['meme']->created_at }}</p>
                </div>
            </div>
        </div>
    </div>
    <div class="row text-center justify-content-center">
        <div class="col-md-12">
            <h3 class="mt-4 mb-0">Tip The Creator</h3>
            <img src="{{ $data['qr'] }}" alt="QR code">
            <p class="">{{ $data['meme']->address->address }}</p>
        </div>
        <div class="col-6">
            <h3 class="mt-4">Monero Tips Recieved</h3>
            <div class="table-responsive-md text-left mt-4">
                <table class="table">
                    <thead>
                        <tr>
                            <th scope="col">Amount</th>
                            <th scope="col">Transaction ID</th>
                            <th scope="col">Date</th>
                        </tr>
                    </thead>
                    <tbody>
                        @foreach ($data['meme']['tips'] as $tip)
                        <tr>
                            <td>{{ $tip->amount_formatted }}</td>
                            <td class="d-inline-block text-truncate" style="max-width: 150px;">
                                <a href="https://testnet.xmrchain.net/tx/{{ $tip->txid }}" target="_blank">
                                    {{ $tip->txid }}
                                </a>
                            </td>
                            <td>{{ $tip->created_at }}</td>
                        </tr>
                        @endforeach
                    </tbody>
                </table>
            </div>
        </div>
    </div>
</div>
@endsection
