<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/


Auth::routes();

Route::get('/', [App\Http\Controllers\MemeController::class, 'index'])->name('homepage');
Route::get('meme/{id}', [App\Http\Controllers\MemeController::class, 'show'])->name('meme');
Route::get('user/{id}', [App\Http\Controllers\UserController::class, 'show'])->name('user');
Route::get('/leaderboard', [App\Http\Controllers\MemeController::class, 'leaderboard'])->name('leaderboard');
Route::get('/about', [App\Http\Controllers\AboutController::class, 'index'])->name('about');
Route::get('/dashboard', [App\Http\Controllers\DashboardController::class, 'index'])->name('dashboard');
Route::get('/submit/meme', [App\Http\Controllers\MemeController::class, 'create'])->name('meme')->middleware('auth');
Route::post('/meme-create', [App\Http\Controllers\MemeController::class, 'store'])->name('meme-create');

// API
Route::get('tips/check', [App\Http\Controllers\TipController::class, 'check']);
Route::get('tips/payout', [App\Http\Controllers\TipController::class, 'payout']);
